<?= $element->renderSubmenu('/10-lekce-soubory'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p>Několikrát už jsme řešili, kde vzít data. A dnes si je vezmeme ze souboru. Respektive dnes se naučíme pracovat se soubory, vytvářet, upravovat, mazat a číst obsah.</p>

<h2 class="text-xl">Vytvoření/Otevření souboru</h2>

<pre class="php">
&lt;?php
    <span class="php__var">$soubor</span> = <span class="php__fun">fopen</span>(<span class="php__str">"soubor.txt"</span>, <span class="php__str">"w+"</span>);
?&gt;
</pre>

<p>
	První parametr je název souboru. Druhý parametr je režim, ve kterém se má soubor otevřít.<br>
	Další režimy jsou:
</p>

<ul>
	<li><b>a</b> - Otevře soubor pro přidání, pokud soubor neexistuje PHP jej vytvoří.</li>
	<li><b>a+</b> - Otevře soubor pro přidávání a čtení, pokud soubor neexistuje PHP jej vytvoří.</li>
	<li><b>r	</b> - Otevře soubor pouze pro čtení.</li>
	<li><b>r+</b> - Otevře soubor pro čtení a zápis.</li>
	<li><b>w	</b> - Otevře soubor pro zápis, původní data budou ztracena. Pokud soubor neexistuje PHP jej vytvoří.</li>
	<li><b>w+</b> - Otevře soubor pro zápis a čtení, původní data budou ztracena. Pokud soubor neexistuje PHP jej vytvoří.</li>
</ul>

<div class="tip">
	<div class="tip__title"><b>Tip:</b></div>
	<p class="tip__text">
		Pokud by Vám na webu někdy nešli ukládat soubory, podívejte se jestli máte správně nastavena práva (<a href="https://cs.wikipedia.org/wiki/Chmod" target="_blank">chmod</a>).
	</p>
</div>


<h2 class="text-xl">Čtení ze souboru</h2>

<pre class="php">
&lt;?php
    <span class="php__var">$soubor</span> = <span class="php__fun">fopen</span>(<span class="php__str">"soubor.txt"</span>, <span class="php__str">"w+"</span>);
    <span class="php__var">$text</span> = <span class="php__fun">fread</span>(<span class="php__var">$soubor</span>, <span class="php__num">10</span>);
    <span class="php__syntax">echo</span> <span class="php__var">$text</span>;
    <span class="php__fun">fclose</span>(<span class="php__var">$soubor</span>);
?&gt;
</pre>

<p>
	Pomocí funkce <a href="https://www.php.net/manual/en/function.fread.php" target="_blank">fread</a> si ze souboru přečteme počet námi zvolených znaků. V příkladu výše jsme načetli 10 znaků. Pokud chceme načíst celý soubor, potřebujeme znát jeho délku.
	To zjistíme pomocí funkce <a href="https://www.php.net/manual/en/function.filesize.php" target="_blank">filesize</a>
</p>

<pre class="php">
&lt;?php
    <span class="php__var">$text</span> = <span class="php__fun">fread</span>(<span class="php__var">$soubor</span>, <span class="php__fun">filesize</span>(<span class="php__str">"soubor.txt"</span>));
?&gt;
</pre>


<h2 class="text-xl">Uložení do souboru</h2>

<pre class="php">
&lt;?php
    <span class="php__var">$text</span> = <span class="php__str">"cokoli, co chcete uložit do souboru"</span>;
    <span class="php__var">$soubor</span> = <span class="php__fun">fopen</span>(<span class="php__str">"soubor.txt"</span>, <span class="php__str">"a+"</span>);
    <span class="php__fun">fwrite</span>(<span class="php__var">$soubor</span>, <span class="php__var">$text</span>);
    <span class="php__fun">fclose</span>(<span class="php__var">$soubor</span>);
?&gt;
</pre>


<h2 class="text-xl">Zavření souboru</h2>

<p>Po ukončení práce se souborem je dobrým zvykem soubor zavřít.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$soubor</span> = <span class="php__fun">fopen</span>(<span class="php__str">"soubor.txt"</span>, <span class="php__str">"w+"</span>);
    .
    .
    .
    <span class="php__fun">fclose</span>(<span class="php__var">$soubor</span>);
?&gt;
</pre>

<h2 class="text-xl">Smazání souboru z disku</h2>
<pre class="php">
&lt;?php
    <span class="php__fun">unlink</span>(<span class="php__str">"soubor.txt"</span>);
?&gt;
</pre>

<p>Se soubory můžete pracovat daleko více. Přehled všech systémových funkcí naleznete v <a href="https://www.php.net/manual/en/ref.filesystem.php" target="_blank">dokumentaci</a>.</p>


<h2 class="mainTitle">Jednodušší práce se soubory</h2>

<p>Pokud chceme načíst všechny data ze souboru můžeme použít funkci <a href="https://www.php.net/manual/en/function.file-get-contents.php" target="_blank">file_get_contents</a>.</p>

<pre class="php">
&lt;?php
    <span class="php__comment">// žádné otevírání, žádné zjišťování délky, žádné zavírání</span>
    <span class="php__var">$text</span> = <span class="php__fun">file_get_contents</span>(<span class="php__str">"soubor.txt"</span>);
    <span class="php__syntax">echo</span> <span class="php__var">$text</span>;
?&gt;
</pre>

<p>A pokud chceme uložit všechna data do souboru, tak to uděláme velmi podobně s funkcí <a href="https://www.php.net/manual/en/function.file-put-contents.php" target="_blank">file_put_contents</a>.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$text</span> = <span class="php__str">"cokoli, co chcete uložit do souboru"</span>;
    <span class="php__fun">file_put_contents</span>(<span class="php__str">"soubor.txt"</span>, <span class="php__var">$text</span>);
?&gt;
</pre>

<p>A nemusíme se bát ani něco do souboru přidat</p>
<pre class="php">
&lt;?php
    <span class="php__var">$text</span> = <span class="php__fun">file_get_contents</span>(<span class="php__str">"soubor.txt"</span>);
    <span class="php__var">$text</span> = <span class="php__var">$text</span> . <span class="php__str">"cokoli, co chcete přidat do souboru"</span>;
    <span class="php__fun">file_put_contents</span>(<span class="php__str">"soubor.txt"</span>, <span class="php__var">$text</span>);
?&gt;
</pre>

<div class="tip">
	<div class="tip__title"><b>Tip:</b></div>
	<p class="tip__text">
		Pokud chcete, aby se text v souboru zalomal na řádky, stačí k textu do <b>dvojitých</b> uvozovek přidat \n (<b>$text = $text . "\n"</b>).<br>
		Ale úplně nejlepší je použít PHP konstantu <a href="https://www.php.net/manual/en/reserved.constants.php" target="_blank">PHP_EOL</a>, která vloží konec řádku za nás.
	</p>
</div>


<h2 class="mainTitle">Tip pro pokročilejší - JSON</h2>

<p>
	<a href="https://www.w3schools.com/js/js_json_intro.asp" target="_blank">JSON</a> není nic jinho než typ souboru (koncovka souboru je obvykle .json). Podobně jako známe textový soubor (.txt) nebo obrázek (.jpg, .png, ...).
	<b>JSON</b> je jedna z možností jak ukládat, posílat a vyměňovat si data mezi 2 webovými stránkami. Používá se proto, protože je jednoduchý na zpracování, dobře čitelný a není potřeba dodatečných technik pro jeho zpracování.
	Rozšířený je možná i proto, protože vychází z Javascriptu (viz odkaz na dokumentaci).
</p>

<p>Do JSONu se především ukládají pole a objekty.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$text</span> = <span class="php__fun">file_get_contents</span>(<span class="php__str">"soubor.json"</span>);
    <span class="php__var">$json</span> = <span class="php__fun">json_decode</span>(<span class="php__var">$text</span>);
?&gt;
</pre>

<p>V proměnné <b>$text</b> je obsah souboru JSON. Ten je dobře čitelný pro člověka, ale špatně pro počítač. Proto jej pomocí funkce <a href="https://www.php.net/manual/en/function.json-decode.php" target="_blank">json_decode</a> převedeme na datový typ objekt (případně pole).</p>

<pre class="php">
&lt;?php
    <span class="php__var">$satnik</span> = <span class="php__syntax">array</span>(
        <span class="php__str">'policka1'</span> => <span class="php__syntax">array</span>(<span  class="php__str">'čepice'</span>, <span  class="php__str">'šály'</span>),
        <span class="php__str">'policka2'</span> => <span class="php__syntax">array</span>(<span  class="php__str">'kapesníky'</span>, <span  class="php__str">'papírové kapesníky'</span>),
        <span class="php__str">'tycNaRaminka'</span> => <span class="php__syntax">array</span>(<span  class="php__str">'tričko'</span>, <span  class="php__str">'bunda'</span>, <span  class="php__str">'černé tričko'</span>),
    );

    <span class="php__var">$json</span> = <span class="php__fun">json_encode</span>(<span class="php__var">$satnik</span>);
    <span class="php__fun">file_put_contents</span>(<span class="php__str">"soubor.json"</span>, $json);
?&gt;
</pre>

<p>Stejně jak dokážeme JSON přečíst, dokážeme JSON i uložit. Datový typ pole nebo objekt jednoduše pomocí funkce <a href="https://www.php.net/manual/en/function.json-encode.php" target="_blank">json_encode</a> převedeme na formát JSON a poté uložíme do souboru.</p>

